[SCOI2016]幸运数字 题解
题目地址:洛谷:【P3292】[SCOI2016]幸运数字 – 洛谷、BZOJ:Problem 4568. — [Scoi2016]幸运数字
题目描述
A 国共有 n 座城市,这些城市由 n-1 条道路相连,使得任意两座城市可以互达,且路径唯一。每座城市都有一个幸运数字,以纪念碑的形式矗立在这座城市的正中心,作为城市的象征。
一些旅行者希望游览 A 国。旅行者计划乘飞机降落在 x 号城市,沿着 x 号城市到 y 号城市之间那条唯一的路径游览,最终从 y 城市起飞离开 A 国。在经过每一座城市时,游览者就会有机会与这座城市的幸运数字拍照,从而将这份幸运保存到自己身上。然而,幸运是不能简单叠加的,这一点游览者也十分清楚。他们迷信着幸运数字是以异或的方式保留在自己身上的。
例如,游览者拍了 3 张照片,幸运值分别是 5,7,11,那么最终保留在自己身上的幸运值就是 9(5 xor 7 xor 11)。
有些聪明的游览者发现,只要选择性地进行拍照,便能获得更大的幸运值。例如在上述三个幸运值中,只选择 5 和 11 ,可以保留的幸运值为 14 。现在,一些游览者找到了聪明的你,希望你帮他们计算出在他们的行程安排中可以保留的最大幸运值是多少。
题意简述
给一棵树,每个点有权值,求两点间路径上所有点的权值取若干个求异或和的最大值。
输入输出格式
输入格式:
第一行包含 2 个正整数 n ,q,分别表示城市的数量和旅行者数量。
第二行包含 n 个非负整数,其中第 i 个整数 Gi 表示 i 号城市的幸运值。
随后 n-1 行,每行包含两个正整数 x ,y,表示 x 号城市和 y 号城市之间有一条道路相连。
随后 q 行,每行包含两个正整数 x ,y,表示这名旅行者的旅行计划是从 x 号城市到 y 号城市。N<=20000,Q<=200000,Gi<=2^60
输出格式:
输出需要包含 q 行,每行包含 1 个非负整数,表示这名旅行者可以保留的最大幸运值。
输入输出样例
输入样例#1:
4 2 11 5 7 9 1 2 1 3 1 4 2 3 1 4
输出样例#1:
14 11
题解
把线性基搞树上去了,我们自然要在树上维护线性基。我们考虑使用倍增法求LCA,并把一个点到它所有倍增父亲这一段路径的线性基预处理出来,在倍增上跳的过程中就是O(\log n)次合并线性基的过程。
倍增LCAO(\log n),维护线性基O(\log n),合并线性基O(\log^2 n),因此总复杂度O(n \log^3 n)。
代码
// Code by KSkun, 2018/5
#include <cstdio>
#include <cctype>
#include <cstring>
#include <algorithm>
#include <vector>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2)
? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(!isdigit(c)) {
if(c == '-') neg = -1;
c = fgc();
}
while(isdigit(c)) {
res = (res << 1) + (res << 3) + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 20005;
std::vector<int> gra[MAXN];
struct LinearBasis {
LL mat[65];
LinearBasis() {
memset(mat, 0, sizeof(mat));
}
inline void insert(LL x) {
for(int i = 60; i >= 0; i--) {
if(x & (1ll << i)) {
if(!mat[i]) {
mat[i] = x; break;
} else {
x ^= mat[i];
}
}
}
}
inline void merge(LinearBasis &x) {
for(int i = 60; i >= 0; i--) {
if(x.mat[i]) insert(x.mat[i]);
}
}
inline LL max() {
LL res = 0;
for(int i = 60; i >= 0; i--) {
res = std::max(res, res ^ mat[i]);
}
return res;
}
} lb[MAXN][20];
int anc[MAXN][20], dep[MAXN];
LL w[MAXN];
inline void dfs(int u) {
for(int i = 1; i < 15; i++) {
anc[u][i] = anc[anc[u][i - 1]][i - 1];
lb[u][i].merge(lb[u][i - 1]);
lb[u][i].merge(lb[anc[u][i - 1]][i - 1]);
}
for(int i = 0; i < gra[u].size(); i++) {
int v = gra[u][i];
if(v == anc[u][0]) continue;
anc[v][0] = u;
dep[v] = dep[u] + 1;
lb[v][0].insert(w[u]);
dfs(v);
}
}
inline LL query(int x, int y) {
LinearBasis res;
if(x == y) {
res.insert(w[x]); return res.max();
}
if(dep[x] > dep[y]) std::swap(x, y);
int del = dep[y] - dep[x];
for(int i = 14; i >= 0; i--) {
if(del & (1 << i)) {
res.merge(lb[y][i]);
y = anc[y][i];
}
}
if(x == y) return res.max();
for(int i = 14; i >= 0; i--) {
if(anc[x][i] != anc[y][i]) {
res.merge(lb[x][i]);
res.merge(lb[y][i]);
x = anc[x][i];
y = anc[y][i];
}
}
res.merge(lb[x][0]);
res.insert(w[y]);
return res.max();
}
int n, q, x, y;
int main() {
n = readint(); q = readint();
for(int i = 1; i <= n; i++) {
w[i] = readint();
lb[i][0].insert(w[i]);
}
for(int i = 1; i < n; i++) {
x = readint(); y = readint();
gra[x].push_back(y);
gra[y].push_back(x);
}
dfs(1);
while(q--) {
x = readint(); y = readint();
printf("%lld\n", query(x, y));
}
return 0;
}